/*
Created using Microdesk MyGeneration NHibernate Template v1.1
[based on MyGeneration/Template/NHibernate (c) by Sharp 1.4]
*/
using System;
using System.Collections;
using System.Collections.Generic;

namespace DataTransfer
{

	/// <summary>
	/// IYoYoCustomer interface for NHibernate mapped table 'viewCustomersWithYoYoOrders'.
	/// </summary>
	public interface IYoYoCustomer
	{
		#region Public Properties
		
		int CustomerId
		{
			get ;
		}
		
		string Firstname
		{
			get ;
		}
		
		string Lastname
		{
			get ;
		}
		
		int OrderId
		{
			get ;
		}
		
		DateTime OrderDate
		{
			get ;
		}
		
		bool IsDeleted { get; set; }
		bool IsChanged { get; set; }
		
		#endregion 
	}

	/// <summary>
	/// YoYoCustomer object for NHibernate mapped table 'viewCustomersWithYoYoOrders'.
	/// </summary>
	[Serializable]
	public partial class YoYoCustomer : ICloneable,IYoYoCustomer
	{
		#region Member Variables

		protected int _customerid;
		protected string _firstname;
		protected string _lastname;
		protected int _orderid;
		protected DateTime _orderdate;
		protected bool _bIsDeleted;
		protected bool _bIsChanged;
		#endregion
		
		#region Constructors
		public YoYoCustomer() {}
		
		#endregion
		
		#region Public Properties
		
		public virtual int CustomerId
		{
			get { return _customerid; }
		}
		
		public virtual string Firstname
		{
			get { return _firstname; }
		}
		
		public virtual string Lastname
		{
			get { return _lastname; }
		}
		
		public virtual int OrderId
		{
			get { return _orderid; }
		}
		
		public virtual DateTime OrderDate
		{
			get { return _orderdate; }
		}
		

		public bool IsDeleted
		{
			get
			{
				return _bIsDeleted;
			}
			set
			{
				_bIsDeleted = value;
			}
		}
		
		public bool IsChanged
		{
			get
			{
				return _bIsChanged;
			}
			set
			{
				_bIsChanged = value;
			}
		}
		
		#endregion 
		
		#region Equals And HashCode Overrides
		/// <summary>
		/// local implementation of Equals based on unique value members
		/// </summary>
		public override bool Equals( object obj )
		{
			if( this == obj ) return true;
			YoYoCustomer castObj = null;
			try
			{
				castObj = (YoYoCustomer)obj;
			} catch(Exception) { return false; } 
			return ( castObj != null );
		}
		/// <summary>
		/// local implementation of GetHashCode based on unique value members
		/// </summary>
		public override int GetHashCode()
		{
		  
			
			int hash = 57; 
			return hash; 
		}
		#endregion
		
		#region ICloneable methods
		
		public object Clone()
		{
			return this.MemberwiseClone();
		}
		
		#endregion
				
		#region Public Property and Mapping Constants

		//Nested class to provide strongly-typed access to property names (for .NET databinding, etc.)
		public static class PropertyNames
		{
			public const string YoYoCustomer = "YoYoCustomer";			
			public const string CustomerId = "CustomerId";			
			public const string Firstname = "Firstname";			
			public const string Lastname = "Lastname";			
			public const string OrderId = "OrderId";			
			public const string OrderDate = "OrderDate";			
		}
		
		//Nested class to provide strongly-typed access to mapping names (for NHibernate Queries, etc.)
		public static class MappingNames
		{
			public const string YoYoCustomer = "YoYoCustomer";			
			public const string _customerid = "_customerid";			
			public const string _firstname = "_firstname";			
			public const string _lastname = "_lastname";			
			public const string _orderid = "_orderid";			
			public const string _orderdate = "_orderdate";			
		}

		#endregion
		
		
	}
	
	#region Custom ICollection interface for YoYoCustomer 

	
	public interface IYoYoCustomerCollection : ICollection
	{
		YoYoCustomer this[int index]{	get; set; }
		void Add(YoYoCustomer pYoYoCustomer);
		void Clear();
	}
	
	[Serializable]
	public class YoYoCustomerCollection : IYoYoCustomerCollection
	{
		private IList<YoYoCustomer> _arrayInternal;

		public YoYoCustomerCollection()
		{
			_arrayInternal = new List<YoYoCustomer>();
		}
		
		public YoYoCustomerCollection( IList<YoYoCustomer> pSource )
		{
			_arrayInternal = pSource;
			if(_arrayInternal == null)
			{
				_arrayInternal = new List<YoYoCustomer>();
			}
		}

		public YoYoCustomer this[int index]
		{
			get
			{
				return _arrayInternal[index];
			}
			set
			{
				_arrayInternal[index] = value;
			}
		}

		public int Count { get { return _arrayInternal.Count; } }
		public bool IsSynchronized { get { return false; } }
		public object SyncRoot { get { return _arrayInternal; } }
		public void CopyTo(Array array, int index){ _arrayInternal.CopyTo((YoYoCustomer[])array, index); }
		public IEnumerator GetEnumerator() { return _arrayInternal.GetEnumerator(); }
		public void Add(YoYoCustomer pYoYoCustomer) { _arrayInternal.Add(pYoYoCustomer); }
		public void Clear() { _arrayInternal.Clear(); }
		public IList<YoYoCustomer> GetList() { return _arrayInternal; }
	 
	
	#endregion
	
	}
}
