﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DataTransfer
{
    public class Order
    {

        #region Fields

        private Customer _customer;

        private DateTime _orderDate;

        private int _orderId;

        private IList<Product> _products;

        #endregion

        #region Properties

        public virtual Customer Customer
        {
            get { return _customer; }
            set
            {
                _customer = value;
            }
        }

        public virtual DateTime OrderDate
        {
            get { return _orderDate; }
            set
            {
                _orderDate = value;
            }
        }

        public virtual int OrderId
        {
            get { return _orderId; }
            set
            {
                _orderId = value;
            }
        }

        public virtual IList<Product> Products
        {
            get { return _products; }
            set
            {
                _products = value;
            }
        }

        #endregion

    }
}
